#include <linux/module.h>

#include <linux/kernel.h>		// printk()
#include <linux/slab.h>			// kmalloc()
#include <linux/fs.h>			// 
#include <linux/errno.h>		// error code
#include <linux/types.h>		// size_t
#include <linux/proc_fs.h>
// #include <linux/fcntl.h>		// O_ACCMODE
#include <linux/seq_file.h>
#include <linux/cdev.h>

// #include <asm/system.h>			// cli(), *_flags
// #include <asm/uaccess.h>		// copy_*_user()

#include "template.h"


int template_read_procmem( char *buf, char **start, off_t offset, int count, int *eof, void *data )
{
	int len = 0;

	return len;
}

static void *template_seq_start( struct seq_file *s, loff_t *pos )
{
	return (void *) NULL;
}

static void *template_seq_next( struct seq_file *s, void *v, loff_t *pos )
{
	return (void *) NULL;
}

static void template_seq_stop( struct seq_file *s, void *v )
{
}

static int template_seq_show( struct seq_file *s, void *v )
{
	return 0;
}

static struct seq_operations template_seq_ops =
{
	.start	= template_seq_start,
	.next	= template_seq_next,
	.stop	= template_seq_stop,
	.show	= template_seq_show
};

static int template_proc_open( struct inode *inode, struct file *file )
{
	return seq_open( file, &template_seq_ops );
}

static struct file_operations template_proc_ops =
{
	.owner		= THIS_MODULE,
	.open		= template_proc_open,
	.read		= seq_read,
	.llseek		= seq_lseek,
	.release	= seq_release
};

void template_create_proc( void )
{
	struct proc_dir_entry *entry;

	create_proc_read_entry( "templatemem", 0, NULL, template_read_procmem, NULL );
	entry = create_proc_entry( "templateseq", 0, NULL );

	if ( entry )
		entry->proc_fops = &template_proc_ops;
}

void template_remove_proc( void )
{
	remove_proc_entry( "templatemem", NULL );
	remove_proc_entry( "templateseq", NULL );
}

